import 'dart:async';

import 'package:flutter/services.dart';
import 'package:pinch/pinch.dart';

class Pinch {
  static const MethodChannel _channel =
      const MethodChannel('com.fluxloop.pinch/sdk');

  static Future<bool> setApiKey(String apiKey) => _channel.invokeMethod('setApiKey', {"apiKey":apiKey});
  static Future<bool> setProductionMode(bool inProduction) => _channel.invokeMethod('setProductionMode', {"enabled":inProduction});
  static Future<bool> setMessagingId(String messagingId) => _channel.invokeMethod('setMessagingId', {"messagingId":messagingId});

  static Future<bool> start() => _channel.invokeMethod('start');
  static Future<bool> stop() => _channel.invokeMethod('stop');

  static Future<bool> addCustomEvent(String type, String json) => _channel.invokeMethod('addCustomEvent', {"json": json, "type": type});
  static Future<bool> setMetadata(String type, String json) => _channel.invokeMethod('setMetadata', {"json": json, "type": type});
  static Future<bool> sendDemographicProfile(int birthYear, String gender) => _channel.invokeMethod('sendDemographicProfile', {"birthYear":birthYear, "gender":gender});


  static Future<bool> setLogLevel(int logLevel) => _channel.invokeMethod('setLogLevel', {"logLevel": logLevel});

  static Future<String> getPrivacyTermsUrl() => _channel.invokeMethod('getPrivacyTermsUrl');
  static Future<String> getPrivacyDashboard(PinchConsent consent) => _channel.invokeMethod('getPrivacyDashboard', {"consentId": consent.value});
  static Future<bool> grant(PinchConsent consent) => _channel.invokeMethod('grant', {"consentId": consent.value});
  static Future<bool> revoke(PinchConsent consent) => _channel.invokeMethod('revoke', {"consentId": consent.value});
  static Future<bool> deleteCollectedData() => _channel.invokeMethod('deleteCollectedData');
  static Future<List<int>> getGrantedConsents() => _channel.invokeMethod('getGrantedConsents');
}
